"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const constants_1 = require("../constants");
exports.ConfigParam = (configKey, fallback = undefined) => (target, propertyKey, parameterIndex) => {
    // Pull existing parameters for this method or create an empty array
    const existingParameters = Reflect.getMetadata(constants_1.CONFIG_PARAMS, target, propertyKey) || [];
    // Add this parameter
    existingParameters.push({ parameterIndex, propertyKey, configKey, fallback });
    // Update the required parameters for this method
    Reflect.defineMetadata(constants_1.CONFIG_PARAMS, existingParameters, target, propertyKey);
    return target;
};
