"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const constants_1 = require("../constants");
const utils_1 = require("../utils");
const module_1 = require("../module");
exports.Configurable = () => {
    return (target, key, descriptor) => {
        const originalMethod = descriptor.value;
        descriptor.value = function (...args) {
            const paramsMetadata = (Reflect.getMetadata(constants_1.CONFIG_PARAMS, target, key) || []).filter(p => {
                return p.propertyKey === key;
            });
            return originalMethod.apply(this, utils_1.applyParamsMetadataDecorator(paramsMetadata, args, module_1.ConfigService.get));
        };
        Reflect.defineMetadata(constants_1.CONFIG_CONFIGURABLE, Reflect.getMetadata(constants_1.CONFIG_PARAMS, target, key) || [], descriptor.value);
        return descriptor;
    };
};
