"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const module_1 = require("./module");
function applyParamsMetadataDecorator(paramsMetadata, args, fn) {
    if (paramsMetadata.length) {
        // Override the original parameter value
        // with the expected property of the value even a deep property.
        for (const param of paramsMetadata) {
            if (Object.keys(param).includes('configKey')) {
                const i = param.parameterIndex;
                if (args[i] instanceof module_1.ConfigService || args[i] === module_1.ConfigService) {
                    // if parameter is a ConfigService instance or ConfigService cass itself
                    // then retrieve required config param from this instance
                    args[param.parameterIndex] = args[i].get(param.configKey, param.fallback);
                }
                else if (args[i] === undefined) {
                    // populate undefined argument with the config parameter value
                    args[param.parameterIndex] = fn(param.configKey, param.fallback);
                }
            }
        }
    }
    return args;
}
exports.applyParamsMetadataDecorator = applyParamsMetadataDecorator;
